#!/bin/sh
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

TOPDIR=`pwd`/../../../../
. ${TOPDIR}tools/build_tools/Path.sh
. ${TOPDIR}tools/build_tools/config.sh
APPS_NAME="busybox"

echo "----------------------------------------------------------------------"
echo "-----------------------      build busybox    ------------------------"
echo "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	make distclean
	rm -f .config
	rm -f .config_ok 
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	#make distclean
	if [ "$IFX_CONFIG_INCAIP" = "1" ]; then
		echo "Inca-IP configuration selected"
            	cp -f ifx_busybox_config_incaip .config
	else
	    if [ "$IFX_CONFIG_INCAIP2" = "1" ]; then
		    echo "Inca-IP2 configuration selected"
	            cp -f ifx_busybox_config_incaip2 .config
	    else
		if [ "$BUILD_2MB_PACKAGE" = "1" ]; then
			if [ "$IFX_CONFIG_WIRELESS" = "1" ]; then
				echo " 2MB Package config file with wlan "
				cp -f ifx_busybox_2MB_config_wlan .config
			else  
				echo " 2MB Package config file without wlan "
				cp -f ifx_busybox_2MB_config .config
			fi	
		else
			if [ "$IFX_CONFIG_WIRELESS" = "1" ]; then
				echo " Full  Package config file with wlan "
				cp -f ifx_busybox_config_wlan .config
			else 
				echo " Full  Package config file without wlan "
				cp -f ifx_busybox_config .config
			fi
		fi
	    fi
	fi
	chmod 664 .config

	if [ "$IFX_CONFIG_TELNET_SERVER" = "1" ]; then
		echo "CONFIG_TELNETD=y" >> .config
		echo "# CONFIG_FEATURE_TELNETD_INACTIVE_TIMEOUT is not set" >> .config
		echo "# CONFIG_FEATURE_TELNETD_INETD is not set" >> .config
	else
		echo "# CONFIG_TELNETD is not set" >> .config
	fi

	if [ "$IFX_CONFIG_DHCP_SERVER" = "1" ]; then
		echo "CONFIG_UDHCPD=y" >> .config
	else
		echo "# CONFIG_UDHCPD is not set" >> .config
	fi

	if [ "$IFX_CONFIG_DHCP_CLIENT" = "1" ]; then
		echo "CONFIG_UDHCPC=y" >> .config
	else
		echo "# CONFIG_UDHCPC is not set" >> .config
	fi

	if [ "$IFX_CONFIG_SYSTEM_LOG" = "1" ]; then
		echo "CONFIG_SYSLOGD=y" >> .config
		echo "CONFIG_FEATURE_ROTATE_LOGFILE=y" >> .config
		echo "CONFIG_FEATURE_IPC_SYSLOG=y" >> .config
		echo "CONFIG_FEATURE_IPC_SYSLOG_BUFFER_SIZE=16" >> .config
		echo "CONFIG_LOGREAD=y" >> .config
		echo "CONFIG_FEATURE_LOGREAD_REDUCED_LOCKING=y" >> .config
		echo "CONFIG_KLOGD=y" >> .config
		echo "CONFIG_LOGGER=y" >> .config
		echo "CONFIG_FEATURE_UDHCP_SYSLOG=y" >> .config

	else
		echo "# CONFIG_SYSLOGD is not set" >> .config
		echo "# CONFIG_LOGGER is not set" >> .config
		echo "# CONFIG_FEATURE_UDHCP_SYSLOG is not set" >> .config
	fi
	
	make oldconfig 
	ifx_error_check $?
	echo -n > .config_ok
fi

if [ "$1" = "config_only" ] ; then
	exit 0
fi

make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" all
ifx_error_check $? 

make PREFIX=${BUILD_ROOTFS_DIR} install 
ifx_error_check $? 
