#ifndef _SIPOPTION_H
#define _SIPOPTION_H

/* configuration event */
#define SIPDHCP_ENABLE_SIPSERVER_OPTION  0x00
#define SIPDHCP_DISABLE_SIPSERVER_OPTION  0x01
#define SIPDHCP_REGISTER_SIPSERVER_CLASS  0x02
#define SIPDHCP_DEREGISTER_SIPSERVER_CLASS  0x03
/* message event */
#define SIPDHCP_ADD_SIPSERVER_OPTION_REQUEST_PARAMETER  0x10
#define SIPDHCP_ADD_SIPSERVER_OPTION  0x11
/* option event */
#define SIPDHCP_NOTIFY_SIPSERVER_LIST  0x20

/* vendor class */
#define SIP_SERVER_CLASS  "sipserver"
#define SIP_CLIENT_CLASS  "sipclient"



struct sipToDhcpMsg {
	struct dhcpMessage *dhcpMsg;
        uint8_t sipDhcpEvtId; /* SIP server DHCP option event id */
};


struct sipToDhcpSipServer {
        uint32_t addr; /* IPv4 address of servers */
        uint8_t *name; /* Domain name of servers */
        struct sipToDhcpSipServer *next; /* next SIP server */
};

int sip_dhcpd_event_handler(struct sipToDhcpMsg *sip_packet, struct dhcpMessage *oldpacket,struct dhcpOfferedAddr *lease);

int sip_dhcpc_event_handler(struct sipToDhcpMsg *sip_packet);


#endif
